/*	
 *	cliprend.h
 *
 *	`惉Cu`܂B
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2003 Naoyuki Sawa
 *
 *	* Wed Feb 13 06:00:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#ifndef __CLIP_REND_H__
#define __CLIP_REND_H__

/* REND_NOASM`C[`A`Ȃasm[`g܂B */
#undef REND_NOASM	/* ܂mɖ`ɂŁc */
//#define REND_NOASM	/* KvɉĒ`Ăi`ƒxȂ܂j */

/*****************************************************************************
 *	
 *****************************************************************************/

#ifdef PIECE
typedef PBMP_FILEHEADER	TEXTUREHEADER;
typedef PIECE_BMP	TEXTURE;
#else /*PIECE*/
typedef struct _TEXTUREHEADER {		/* PBMP_FILEHEADERɃoCi݊ */
	unsigned long head;		/* + 0,4 VOl`'PBMP'        */
	unsigned long fsize;		/* + 4,4 t@CTCY          */
	unsigned char bpp;		/* + 8,1 rbg[x              */
	unsigned char mask;		/* + 9,1 }XN[x              */
	short w;			/* +10,2                       */
	short h;			/* +12,2                     */
					/* +14,2 pfBO              */
	unsigned long buf_size;		/* +16,4 f[^TCY            */
					/* =20                           */
} TEXTUREHEADER;
typedef struct _TEXTURE {		/* PIECE_BMPɃoCi݊ */
	TEXTUREHEADER header;		/* + 0,20 wb_           */
	unsigned char* buf;		/* +20, 4 rbgf[^     */
	unsigned char* mask;		/* +24, 4 }XNf[^     */
					/* =28                     */
} TEXTURE;
#endif /*PIECE*/

/* SURFACE\̂́APIECE_VRAM\̂̏ʃoCi݊łB
 * PIECE_VRAMւ̃|C^v֐ɁASURFACEւ̃|C^n܂B
 */
typedef struct _SURFACE {		/* `T[tFCX   */
	short w;			/* + 0,2              */
	short h;			/* + 2,2            */
	unsigned char* vbuff;		/* + 4,4 J[obt@ */
	/* ܂PIECE_VRAM݊Bȍ~͊głB */
	unsigned char* zbuff;		/* + 8,4 yobt@     */
					/* =12                  */
} SURFACE;

typedef struct _VERTEX {		/* |S_          */
	short x;			/* +0,2 sNZW */
	short y;			/* +2,2 sNZW */
	unsigned char s;		/* +4,1 eNZW */
	unsigned char t;		/* +5,1 eNZW */
} VERTEX;				/* =6                    */

typedef struct _TCOORD {		/* eNX`W */
	unsigned char s;		/* +0,1 W  */
	unsigned char t;		/* +1,1 W  */
					/* =2             */
} TCOORD;

typedef struct _FACEVERTEX {		/* tFCX_                  */
	unsigned char iv;		/* +0,1 _WCfNX       */
	unsigned char ic;		/* +1,1 eNX`WCfNX */
} FACEVERTEX;

typedef struct _FACE {			/* tFCX                      */
	unsigned char nfv;		/* +0,1    _̐              */
	unsigned char c;		/* +1,1    J[                */
	/*FACEVERTEX fv[nfv];*/		/* +2,2nfv tFCX_Xg    */
					/* =2+2nfv                       */
} FACE;

typedef struct _MESH {			/* bV                             */
	unsigned char nv;		/* +0,1            _W̐         */
	unsigned char nc;		/* +1,1            eNX`W̐   */
	unsigned char nf;		/* +2,1            tFCX̐         */
	unsigned char reserved;		/* +3,1            (\)               */
	/*vector v[nv];*/		/* +4,12nv         _WXg       */
	/*TCOORD c[nc];*/		/* +4+12nv,2nc     eNX`WXg */
	/*FACE f[nf];*/			/* +4+12nv+2nc,(?) tFCXXg       */
					/* =4+12nv+2nc+(?)                      */
} MESH;

/*****************************************************************************
 *	gp
 *****************************************************************************/

/* NbsOp_ */
typedef struct _CLIPVERTEX {
	fixed x, y, z;		/* + 0,12 _W       */
	fixed s, t;		/* +12, 8 eNX`W */
				/* =20                   */
} CLIPVERTEX;

/* `p_ */
typedef struct _RENDVERTEX {
	unsigned short x, y;	/* + 0,4 _W               */
	unsigned short z;	/* + 4,2 yl(8.8bit)           */
	unsigned short s, t;	/* + 6,4 eNX`W(8.8bit) */
				/* =10                          */
} RENDVERTEX;

/* DDA */
typedef struct _DDA {
	int n;			/* + 0,4 [̑     */
	int d;			/* + 4,4 [             */
	int u;			/* + 8,4 ̕ω     */
	int v;			/* +12,4 Jグ̕ω */
				/* =16                    */
} DDA;

/* draw_scanline_*_*()ֈnp[^̍\̂łB
 * draw_scanline_*_*()̓AZuō̂ŁAmɃItZbgŒƂ邽߂ɁA̍\̂pӂ܂B
 */
typedef struct _DSLPARAM {
	/* T[tFCX */
	unsigned short surface_w;			/*  0, 2:  */
	unsigned short surface_h;			/*  2, 2:  */
	unsigned char* surface_vbuff;			/*  4, 4: J[obt@ */
	unsigned char* surface_zbuff;			/*  8, 4: yobt@ */
	/* eNX` */
	unsigned short texture_w;			/* 12, 2:  */
	unsigned short texture_h;			/* 14, 2:  */
	unsigned char* texture_buf;			/* 16, 4: C[W */
	unsigned char* texture_mask;			/* 20, 4: }XN */
	/* J[ */
	unsigned char back_color;			/* 24, 1: wiF */
	unsigned char fore_color;			/* 25, 1: OiF */
} DSLPARAM;

/* XLC`֐̖{̂łBAvP[V璼ڗpȂŉB */
typedef void (*DSLPROC)(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);
/* (yRyA) */
void draw_scanline_wz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds11.c */
void draw_scanline_wz_1bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds12.c(\) */
void draw_scanline_wz_1bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds13.c(\) */
void draw_scanline_wz_2bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds14.c */
void draw_scanline_wz_2bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds15.c */
/* (yRyAȂ) */
void draw_scanline_woz_color(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds21.c(\) */
void draw_scanline_woz_1bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds22.c(\) */
void draw_scanline_woz_1bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds23.c(\) */
void draw_scanline_woz_2bit(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds24.c(\) */
void draw_scanline_woz_2bitmask(const RENDVERTEX* v0, const RENDVERTEX* v1, DSLPARAM* param);	/* framds25.c(\) */

/*****************************************************************************
 *	
 *****************************************************************************/

/* eNX`\̂܂B
 * [in]
 *	texture		eNX`\́B
 *	data		PBMPt@CC[W̐擪AhXB
 * [out]
 *	߂l		texture̒l̂܂ܕԂ܂B
 * [note]
 *	* TEXTURE\̂PIECE_BMP\̂Ɠ(typedef)Ȃ̂ŁA
 *	  ̊֐PIECE_BMP\̂̏ɂpł܂B
 */
TEXTURE* texture_init(TEXTURE* texture, const void* data);

/* T[tFCXNA܂B
 * [in]
 *	surface		T[tFCX\́B
 *	color		wiFB
 * [note]
 *	* J[obt@(vbuff)NULLłȂ΁AwiFŃNA܂B
 *	* yobt@(zbuff)NULLłȂ΁A0xFFŃNA܂B
 */
void surface_clear(SURFACE* surface, int color);

/* sNZJ[擾܂B
 * [in]
 *	surface		T[tFCX\́B
 *	x,y		sNZWB
 * [out]
 *	߂l		sNZJ[B
 *			T[tFCXÕsNZWȂA-1Ԃ܂B
 * [note]
 *	* ̊֐́Arender_point()Ƒ΂𐬂܂B
 */
int surface_point(SURFACE* surface, int x, int y);

/*****************************************************************************
 *	RENDER
 *****************************************************************************/

#define RENDER_CONTEXT_STACK_SIZE	16			/* ReLXgX^bNTCY */

typedef struct _RENDERCONTEXT {
	matrix matrix;						/* ϊs               */
	TEXTURE* texture;					/* eNX`(NULL:Ȃ)  */
} RENDERCONTEXT;

typedef struct _RENDER {
	SURFACE* surface;					/* `T[tFCX                 */
	short left, top, right, bottom;				/* r[|[g`(ObhWn) */
	fixed front, back;					/* NbsO                 */
	RENDERCONTEXT* context;					/* ReLXgX^bNgbv       */
	RENDERCONTEXT context_stack[RENDER_CONTEXT_STACK_SIZE];	/* ReLXgX^bN             */
} RENDER;

/* t[܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	surface		`T[tFCXB
 *	x,y		r[|[g_B
 *	width,height	r[|[gTCYB
 *	front,back	NbsOB
 *	fovy		pxB
 * [note]
 *	* width,height0w肷ƁAT[tFCX̕AƓƌȂ܂B
 *	  ]āAT[tFCXŜr[|[g̈ƂĎw肷ɂ́A
 *	  x,y,width,height0,0,0,0Ǝw肷̂ȒPłB
 *	* 3D`sȂꍇ́Afront,back,fovyɑS0w肵ĂB
 *	  front,back,fovyɑS0w肵ꍇAϊs͏܂B
 *	* ̊֐́AT[tFCX̃NAs܂B
 *	  J[obt@тyobt@̃NÁAĂяoōsĂB
 *	* 2003/09/14: 2Dp3Dpɏ֐𕪂܂B
 *	  2DpƂďꍇ́Afront/back/fovy0w肷Kv͂܂B
 */
void render_init_2d(RENDER* render, SURFACE* surface, int x, int y, int width, int height);
void render_init_3d(RENDER* render, SURFACE* surface, int x, int y, int width, int height, fixed front, fixed back, fixed fovy);

/* ReLXgޔ܂B
 * [in]
 *	render		_[ւ̃|C^B
 */
void render_save(RENDER* render);

/* ReLXg𕜌܂B
 * [in]
 *	render		_[ւ̃|C^B
 */
void render_restore(RENDER* render);

/* _`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x,y		_̍WB
 *	color		J[B
 * [note]
 *	* ̊֐́Asurface_point()Ƒ΂𐬂܂B
 */
void render_point(RENDER* render, int x, int y, int color);

/* F͈̔͂hԂ܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x0,y0		hԂJn_B
 *	color		J[B
 * [out]
 *	߂l		hsNZ̐B
 * [note]
 *	* (x0,y0)̐F͈͂AcolorœhԂ܂B
 *	  (x0,y0)̐FcolorƓȂA܂B
 *	* (x0,y0)r[|[gOȂA܂B
 */
int render_paint(RENDER* render, int x0, int y0, int color);

/* `܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x0,y0		n_WB
 *	x1,y1		I_WB
 *	color		J[B
 * [note]
 *	* p``߂ɁAAČĂяo邱Ƃz肵Ă܂B
 *	  āAI_sNZ(x1,y1)͕`܂B
 *	* ̓sANbsOꂽ̏I_`Ȃ̂ŁA
 *	  ʓʊOւ̐`ƂƁAʒ[1sNZ
 *	  ԂłĂ܂܂BvCB
 *	* Fri Mar  8 07:00:00 JST 2002 Naoyuki Sawa
 *	  C܂B
 */
void render_line(RENDER* render, int x0, int y0, int x1, int y1, int color);

/* j`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x0,y0		n_WB
 *	x1,y1		I_WB
 *	i_pat		jp^[̊JnCfbNXB
 *	pat		jp^[B(J[l̔zBl4ȏ͓)
 *	n_pat		jp^[̗vfB(1ȏ)
 * [out]
 *	߂l		jp^[̏ICfbNX{PB
 *			A`Ƃ́A̖߂lrender_dashes()Ăяoi_patɓn΁A
 *			jp^[܂Ȃ܂B
 * [note]
 *	* n_pat0w肷ƁA[ZG[܂B
 *	* i_pat>=n_patł\܂BK؂ȌJԂʒuJn܂B
 */
int render_dashes(RENDER* render, int x0, int y0, int x1, int y1, unsigned i_pat, const unsigned char* pat, unsigned n_pat);

/* ``܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x,y		㌴_WB
 *	w,h		`̃TCYB
 *	color		J[B
 */
void render_rectangle(RENDER* render, int x, int y, int w, int h, int color);

/* `hԂ܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	x,y		㌴_WB
 *	w,h		`̃TCYB
 *	color		J[B
 */
void render_rectangle_fill(RENDER* render, int x, int y, int w, int h, int color);

/* |S`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	vertices	_XgB
 *	n_vertices	_̐B
 *	color		J[B
 */
void render_polygon(RENDER* render, const VERTEX* vertices, int n_vertices, int color);

/* bV`܂B
 * [in]
 *	render		_[ւ̃|C^B
 *	mesh		`悳郁bVB
 */
void render_mesh(RENDER* render, const MESH* mesh);

#endif /*__CLIP_REND_H__*/
